<template>
  <div>
    <form
      v-if="isBusiness"
      id="profileForm"
      novalidate="novalidate"
    >
      <div class="form-group required">
        <label
          for="companyName"
        >Domaine&nbsp;:</label>
        <input
          id="companyName"
          v-model="profile.companyName"
          name="companyName"
          type="text"
          class="form-control"
          required="required"
        >
      </div>
      <div class="form-group required">
        <label
          for="firstname"
        >Prénom&nbsp;:</label>
        <input
          id="firstname"
          v-model="profile.firstname"
          name="firstname"
          type="text"
          class="form-control"
          required="required"
        >
      </div>
      <div class="form-group required">
        <label
          for="lastname"
        >Nom&nbsp;:</label>
        <input
          id="lastname"
          v-model="profile.lastname"
          name="lastname"
          type="text"
          class="form-control"
          required="required"
        >
      </div>
      <div class="form-group required">
        <label
          for="email"
        >Email&nbsp;:</label>
        <input
          id="email"
          v-model="profile.email"
          name="email"
          type="email"
          class="form-control"
          required="required"
          disabled="disabled"
        >
      </div>
      <div class="form-group required">
        <label
          for="phoneNumber"
        >Numéro de téléphone&nbsp;:</label>
        <input
          id="phoneNumber"
          v-model="profile.phoneNumber"
          name="phoneNumber"
          type="number"
          class="form-control"
          required="required"
          minlength="10"
        >
      </div>
      <div class="form-group required">
        <label
          for="addressLine1"
        >Adresse&nbsp;:</label>
        <input
          id="addressLine1"
          v-model="profile.addressLine1"
          name="addressLine1"
          type="text"
          class="form-control"
          required="required"
        >
      </div>
      <div class="form-group">
        <label
          for="addressLine2"
        >Complément d'adresse&nbsp;:</label>
        <input
          id="addressLine2"
          v-model="profile.addressLine2"
          name="addressLine2"
          type="text"
          class="form-control"
        >
      </div>
      <div class="form-group required">
        <label
          for="postalCode"
        >Code postal&nbsp;:</label>
        <input
          id="postalCode"
          v-model="profile.postalCode"
          name="postalCode"
          type="number"
          maxlength="5"
          minlength="5"
          class="form-control"
          required="required"
        >
      </div>
      <div class="form-group required">
        <label
          for="city"
        >Ville&nbsp;:</label>
        <input
          id="city"
          v-model="profile.city"
          name="city"
          type="text"
          class="form-control"
          required="required"
        >
      </div>
      <div class="form-group btn-list">
        <click-button
          :disabled="isLoading"
          @click="update()"
        >
          <template slot="content">
            Mettre à jour
          </template>
        </click-button>
      </div>
    </form>
    <div
      v-if="!isBusiness"
      class="form-group"
    >
      <label
        for="email"
      >Email&nbsp;:</label>
      <input
        id="email"
        v-model="user.email"
        name="email"
        type="email"
        class="form-control"
        required="required"
        disabled="disabled"
      >
    </div>
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";
import VanillaToasts from "vanillatoasts";
import ClickButton from "../../../../components/Button/ClickButton";

export default {
  name: "PersonnalData",
  components: {ClickButton},
  data() {
    return {
      profileFormvalidator: null
    }
  },
  computed: {
    ...mapGetters([
      'user',
      'profile',
      'isLoading',
      'isBusiness',
      'isManager',
      'isAdmin'
    ]),
  },
  created() {
    if(!this.isManager && !this.isAdmin) {
      this.fetchProfile()
    }
  },
  mounted() {
    this.profileFormvalidator = $('#profileForm').submit(function(e) {
      e.preventDefault();
    }).validate({
      rules: {
        email: {
          required: true,
          email: true
        },
        companyName: 'required',
        firstname: 'required',
        lastname: 'required',
        addressLine1: 'required',
        postalCode: {
          required: true,
          maxlength: 5,
          minlength: 5,
          digits: true
        },
        city: 'required',
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass("help-block");
        if(element[0]['name']=== "password") {
          error.insertAfter(element[0]['parentElement'])
        }else if (element.prop("type") === "checkbox") {
          error.insertAfter(element.parent("label"));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'fetchProfile',
      'updateProfile',
      'loadingStarts',
      'loadingEnds',
    ]),
    update () {
      if($("#profileForm").valid()) {
        this.loadingStarts();
        this.updateProfile(this.profile).then(
          () => {
            VanillaToasts.create({
              title: 'Informations personnelles',
              text: 'Mise à jour effectuée',
              type: 'success',
              timeout: 5000, // hide after 5000ms, // optional paremter
            });
            this.loadingEnds();
          }
        );
      }
    }
  }
}
</script>

<style scoped>

</style>